; ##############################################################################
; ##############################################################################
; ##############################################################################
MENUE:
	; ALARM zurckstellen	
	LDS temp,(adr_TASTE)
	tst temp
	breq MENUE_w
	STS(adr_ALARM_WERT),NULL
MENUE_w:
	; BELEUCHTUNG an
	LDS temp,(adr_MENUE)
	tst temp
	breq MENUE_ww
	cbi (LED_BEL_PORT),(LED_BEL_PIN_NR)			; Beleuchtung an	
MENUE_ww:
	LDS temp,(adr_TASTE)
	; MENUE PLUS	
	cpi temp, (TASTE_MENUE_PLUS)
	breq MENUE_PLUS
	; MENUE MINUS	
	cpi temp, (TASTE_MENUE_MINUS)
	breq MENUE_MINUS
	rjmp MENUE_START
MENUE_PLUS:
	LDS temp,(adr_MENUE)
	inc temp
	STS(adr_MENUE),temp 
	rjmp MENUE_START
MENUE_MINUS:
	LDS temp,(adr_MENUE)
	tst temp
	breq MENUE_START
	dec temp
	STS(adr_MENUE),temp 
	rjmp MENUE_START
;-------------------------------------------------------------------------------
MENUE_START:
	; Z-Zeiger	
	ldi ZL, low(MENUE_SPRUNGMARKE)
	ldi ZH,high(MENUE_SPRUNGMARKE)
	; MENUE		
	LDS temp,(adr_MENUE)
	; addieren	
	add ZL,temp
	adc ZH,NULL
	; SPRUNG	
	ijmp

MENUE_SPRUNGMARKE:
	rjmp MENUE_DATUM_ZEIT
	rjmp MENUE_DATUM_ZEIT
	rjmp MENUE_SENSOR_BMA020
	rjmp MENUE_SENSOR_BMA020_G
	rjmp MENUE_EDIT_mm	
	rjmp MENUE_EDIT_hh
	rjmp MENUE_EDIT_TAG
	rjmp MENUE_EDIT_MONAT
	rjmp MENUE_EDIT_JAHR
	rjmp MENUE_EDIT_ALARM_SCHWELLE
	rjmp MENUE_EDIT_KONTRAST
;	rjmp MENUE_WARTUNG
;-------------------------------------------------------------------------------
	; SPEICHERN	
	rcall EEPROM_KONFIGURATION_SPEICHERN

	ldi temp9,20
MENUE_S:
	cbi (LED_BEL_PORT),(LED_BEL_PIN_NR)			; Beleuchtung an	
	rcall wait_100ms
	sbi (LED_BEL_PORT),(LED_BEL_PIN_NR)			; Beleuchtung aus
	rcall wait_100ms
	dec temp9
	brne MENUE_S

	STS(adr_ALARM_WERT),NULL
	STS(adr_MENUE),NULL

ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
MENUE_DATUM_ZEIT:
	LDS temp,(adr_ALARM_WERT)
	cpi temp,2
	brlo MENUE_DATUM_ZEIT_RUN
	ret
;-------------------------------------------------------------------------------
MENUE_DATUM_ZEIT_RUN:
	rcall LCD_PAGE_0_CLEAR
	rcall LCD_ANZEIGE_DATUM_KURZ
;-------------------------------------------------------------------------------
	LDS temp,(adr_ALARM_WERT)
	tst temp
	breq MENUE_DATUM_ZEIT_w
	ldi temp,'A'
	STS(adr_LCD_PAGE0+10),temp
	ldi temp,'L'
	STS(adr_LCD_PAGE0+11),temp
MENUE_DATUM_ZEIT_w:
;-------------------------------------------------------------------------------
	rjmp LCD_ANZEIGE_ZEIT_KURZ
; ##############################################################################
; ##############################################################################
; ##############################################################################
MENUE_SENSOR_BMA020:
	rcall LCD_PAGE_0_CLEAR

	LDS temp1,(adr_BMA020_X_LSB)
	LDS temp2,(adr_BMA020_X_MSB)
	rcall LCD_AUSGABE_ZAHL_5_STELLEN_NEGATIV_FORMATIERT_TEMP1_TEMP2
	STS(adr_LCD_PAGE0+0),temp6
	STS(adr_LCD_PAGE0+1),temp5
	STS(adr_LCD_PAGE0+2),temp4
	STS(adr_LCD_PAGE0+3),temp3
	STS(adr_LCD_PAGE0+4),temp2
	STS(adr_LCD_PAGE0+5),temp1

	LDS temp1,(adr_BMA020_Y_LSB)
	LDS temp2,(adr_BMA020_Y_MSB)
	rcall LCD_AUSGABE_ZAHL_5_STELLEN_NEGATIV_FORMATIERT_TEMP1_TEMP2
	STS(adr_LCD_PAGE0+7),temp6
	STS(adr_LCD_PAGE0+8),temp5
	STS(adr_LCD_PAGE0+9),temp4
	STS(adr_LCD_PAGE0+10),temp3
	STS(adr_LCD_PAGE0+11),temp2
	STS(adr_LCD_PAGE0+12),temp1

	LDS temp1,(adr_BMA020_Z_LSB)
	LDS temp2,(adr_BMA020_Z_MSB)
	rcall LCD_AUSGABE_ZAHL_5_STELLEN_NEGATIV_FORMATIERT_TEMP1_TEMP2
	STS(adr_LCD_PAGE0+14),temp6
	STS(adr_LCD_PAGE0+15),temp5
	STS(adr_LCD_PAGE0+16),temp4
	STS(adr_LCD_PAGE0+17),temp3
	STS(adr_LCD_PAGE0+18),temp2
	STS(adr_LCD_PAGE0+19),temp1
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
MENUE_SENSOR_BMA020_G:
	rcall LCD_PAGE_0_CLEAR
	ldi temp,'g'
	STS(adr_LCD_PAGE0+0),temp	
	ldi temp,':'
	STS(adr_LCD_PAGE0+1),temp	

	LDS temp1,(adr_BMA020_G_LSB)
	LDS temp2,(adr_BMA020_G_MSB)
	rcall LCD_AUSGABE_ZAHL_5_STELLEN_NEGATIV_FORMATIERT_TEMP1_TEMP2
	STS(adr_LCD_PAGE0+2),temp6
	STS(adr_LCD_PAGE0+3),temp5
	STS(adr_LCD_PAGE0+4),temp4
	STS(adr_LCD_PAGE0+5),temp3
	STS(adr_LCD_PAGE0+6),temp2
	STS(adr_LCD_PAGE0+7),temp1
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
MENUE_WARTUNG:
	rcall LCD_PAGE_0_CLEAR
	ldi temp,'T'
	STS(adr_LCD_PAGE0+0),temp	
	ldi temp,':'
	STS(adr_LCD_PAGE0+1),temp	

	LDS temp1,(adr_TASTE)
	clr temp2
	rcall LCD_AUSGABE_ZAHL_5_STELLEN_NEGATIV_FORMATIERT_TEMP1_TEMP2
	STS(adr_LCD_PAGE0+2),temp6
	STS(adr_LCD_PAGE0+3),temp5
	STS(adr_LCD_PAGE0+4),temp4
	STS(adr_LCD_PAGE0+5),temp3
	STS(adr_LCD_PAGE0+6),temp2
	STS(adr_LCD_PAGE0+7),temp1

ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
MENUE_EDIT_MM:
	rcall LCD_PAGE_0_CLEAR
	rcall LCD_ANZEIGE_EDIT_KURZ
	ldi temp,'m'
	STS(adr_LCD_PAGE0+5),temp
	ldi temp,'m'
	STS(adr_LCD_PAGE0+6),temp

	LDS temp1,(adr_mm)
	rcall WERT_PLUS_MINUS_TEMP1
	cpi temp1,59+1
	brlo MENUE_EDIT_MM_w
	ldi temp1,59
MENUE_EDIT_MM_w:
	STS(adr_mm),temp1
	rjmp LCD_ANZEIGE_ZEIT_KURZ
; ##############################################################################
; ##############################################################################
; ##############################################################################
MENUE_EDIT_HH:
	rcall LCD_PAGE_0_CLEAR
	rcall LCD_ANZEIGE_EDIT_KURZ
	ldi temp,'h'
	STS(adr_LCD_PAGE0+5),temp
	ldi temp,'h'
	STS(adr_LCD_PAGE0+6),temp

	LDS temp1,(adr_hh)
	rcall WERT_PLUS_MINUS_TEMP1
	cpi temp1,23+1
	brlo MENUE_EDIT_HH_w
	ldi temp1,23
MENUE_EDIT_HH_w:
	STS(adr_hh),temp1
	rjmp LCD_ANZEIGE_ZEIT_KURZ
; ##############################################################################
; ##############################################################################
; ##############################################################################
MENUE_EDIT_TAG:
	rcall LCD_PAGE_0_CLEAR
	rcall LCD_ANZEIGE_EDIT_KURZ
	ldi temp,'T'
	STS(adr_LCD_PAGE0+5),temp
	ldi temp,'a'
	STS(adr_LCD_PAGE0+6),temp
	ldi temp,'g'
	STS(adr_LCD_PAGE0+7),temp

	LDS temp1,(adr_TAG)
	rcall WERT_PLUS_MINUS_TEMP1
	cpi temp1,31+1
	brlo MENUE_EDIT_TAG_w
	ldi temp1,31
MENUE_EDIT_TAG_w:
	STS(adr_TAG),temp1
	rjmp LCD_ANZEIGE_DATUM_RECHTS_KURZ
; ##############################################################################
; ##############################################################################
; ##############################################################################
MENUE_EDIT_MONAT:
	rcall LCD_PAGE_0_CLEAR
	rcall LCD_ANZEIGE_EDIT_KURZ
	ldi temp,'M'
	STS(adr_LCD_PAGE0+5),temp
	ldi temp,'o'
	STS(adr_LCD_PAGE0+6),temp
	ldi temp,'n'
	STS(adr_LCD_PAGE0+7),temp
	ldi temp,'a'
	STS(adr_LCD_PAGE0+8),temp
	ldi temp,'t'
	STS(adr_LCD_PAGE0+9),temp

	LDS temp1,(adr_MONAT)
	rcall WERT_PLUS_MINUS_TEMP1
	cpi temp1,12+1
	brlo MENUE_EDIT_MONAT_w
	ldi temp1,12
MENUE_EDIT_MONAT_w:
	STS(adr_MONAT),temp1
	rjmp LCD_ANZEIGE_DATUM_RECHTS_KURZ
; ##############################################################################
; ##############################################################################
; ##############################################################################
MENUE_EDIT_JAHR:
	rcall LCD_PAGE_0_CLEAR
	rcall LCD_ANZEIGE_EDIT_KURZ
	ldi temp,'J'
	STS(adr_LCD_PAGE0+5),temp
	ldi temp,'a'
	STS(adr_LCD_PAGE0+6),temp
	ldi temp,'h'
	STS(adr_LCD_PAGE0+7),temp
	ldi temp,'r'
	STS(adr_LCD_PAGE0+8),temp

	LDS temp1,(adr_JAHR)
	rcall WERT_PLUS_MINUS_TEMP1
	cpi temp1,14
	brsh MENUE_EDIT_JAHR_w
	ldi temp1,14
MENUE_EDIT_JAHR_w:
	STS(adr_JAHR),temp1
	rjmp LCD_ANZEIGE_DATUM_RECHTS_KURZ
; ##############################################################################
; ##############################################################################
; ##############################################################################
MENUE_EDIT_ALARM_SCHWELLE:
	rcall LCD_PAGE_0_CLEAR
	rcall LCD_ANZEIGE_EDIT_KURZ
	ldi temp,'A'
	STS(adr_LCD_PAGE0+5),temp
	ldi temp,'L'
	STS(adr_LCD_PAGE0+6),temp
	ldi temp,'A'
	STS(adr_LCD_PAGE0+7),temp
	ldi temp,'R'
	STS(adr_LCD_PAGE0+8),temp
	ldi temp,'M'
	STS(adr_LCD_PAGE0+9),temp

	LDS temp1,(adr_ALARM_SCHWELLE)
	rcall WERT_PLUS_MINUS_TEMP1
	cpi temp1,100+1
	brlo MENUE_EDIT_ALARM_SCHWELLE_w
	ldi temp1,100
MENUE_EDIT_ALARM_SCHWELLE_w:
	STS(adr_ALARM_SCHWELLE),temp1
	rcall LCD_AUSGABE_ZAHL_3_STELLEN_TEMP1
	STS(adr_LCD_PAGE0+18),temp3
	STS(adr_LCD_PAGE0+19),temp2
	STS(adr_LCD_PAGE0+20),temp1
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
MENUE_EDIT_KONTRAST:
	rcall LCD_PAGE_0_CLEAR
	rcall LCD_ANZEIGE_EDIT_KURZ
	ldi temp,'K'
	STS(adr_LCD_PAGE0+5),temp
	ldi temp,'O'
	STS(adr_LCD_PAGE0+6),temp
	ldi temp,'N'
	STS(adr_LCD_PAGE0+7),temp
	ldi temp,'T'
	STS(adr_LCD_PAGE0+8),temp
	ldi temp,'R'
	STS(adr_LCD_PAGE0+9),temp
	ldi temp,'A'
	STS(adr_LCD_PAGE0+10),temp
	ldi temp,'S'
	STS(adr_LCD_PAGE0+11),temp
	ldi temp,'T'
	STS(adr_LCD_PAGE0+12),temp


	LDS temp1,(adr_LCD_KONTRAST)
	rcall WERT_PLUS_MINUS_TEMP1
	STS(adr_LCD_KONTRAST),temp1
	rcall LCD_AUSGABE_ZAHL_3_STELLEN_TEMP1
	STS(adr_LCD_PAGE0+18),temp3
	STS(adr_LCD_PAGE0+19),temp2
	STS(adr_LCD_PAGE0+20),temp1
	rjmp LCD_CONTRAST
; ##############################################################################
; ##############################################################################
; ##############################################################################
WERT_PLUS_MINUS_TEMP1:
	LDS temp,(adr_TASTE) 
	cpi temp,(TASTE_PLUS)
	breq WERT_PLUS_MINUS_TEMP1_PLUS
	cpi temp,(TASTE_MINUS)
	breq WERT_PLUS_MINUS_TEMP1_MINUS
	ret
WERT_PLUS_MINUS_TEMP1_PLUS:
	cpi temp1,255
	brne WERT_PLUS_MINUS_TEMP1_PLUS_w
	ret
WERT_PLUS_MINUS_TEMP1_PLUS_w:
	inc temp1
	ret
WERT_PLUS_MINUS_TEMP1_MINUS:
	tst temp1
	brne WERT_PLUS_MINUS_TEMP1_MINUS_w
	ret
WERT_PLUS_MINUS_TEMP1_MINUS_w:
	dec temp1
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
