; ##############################################################################
; ##############################################################################
; ##############################################################################
LCD_BEGRUSSUNG:
	ldi ZH, high(TEXT_BEGRUESSUNG*2)	; TEXT 
	ldi ZL,  low(TEXT_BEGRUESSUNG*2)

	ldi YH, high(adr_LCD_PAGE0)
	ldi YL,  low(adr_LCD_PAGE0)
	rcall ANZEIGE_TEXT_Z_Y
	rcall LCD_ZEICHNEN
	rcall WAIT_100ms
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
LCD_TEST:
	rcall LCD_VOLL
	rcall wait_1s
	rcall LCD_CLEAR
	rcall wait_100ms
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
LCD_ANZEIGE_ZEIT_KURZ:
	; STUNDE 	
	LDS temp1,(adr_hh)
	clr temp2
	clr temp3
	clr temp4
	rcall FUNKTION_HEX_ASC_32	; INPUT: temp1...4 OUTPUT: Temp1...8
	STS(adr_LCD_PAGE0+13),temp2
	STS(adr_LCD_PAGE0+14),temp1
	; ":"		
	ldi temp,':'
	STS(adr_LCD_PAGE0+15),temp	
	; Minute	
	LDS temp1,(adr_mm)
	clr temp2
	clr temp3
	clr temp4
	rcall FUNKTION_HEX_ASC_32	; INPUT: temp1...4 OUTPUT: Temp1...8
	STS(adr_LCD_PAGE0+16),temp2
	STS(adr_LCD_PAGE0+17),temp1
	; ":"		
	ldi temp,':'
	STS(adr_LCD_PAGE0+18),temp	
	; SEKUNDE	
	LDS temp1,(adr_ss)
	clr temp2
	clr temp3
	clr temp4
	rcall FUNKTION_HEX_ASC_32	; INPUT: temp1...4 OUTPUT: Temp1...8
	STS(adr_LCD_PAGE0+19),temp2
	STS(adr_LCD_PAGE0+20),temp1	
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
LCD_ANZEIGE_DATUM_KURZ:
	; TAG		
	LDS temp1,(adr_TAG)
	clr temp2
	clr temp3
	clr temp4
	rcall FUNKTION_HEX_ASC_32	; INPUT: temp1...4 OUTPUT: Temp1...8
	STS(adr_LCD_PAGE0+0),temp2
	STS(adr_LCD_PAGE0+1),temp1
	ldi temp,'.'
	STS(adr_LCD_PAGE0+2),temp
	; MONAT 	
	LDS temp1,(adr_MONAT)
	clr temp2
	clr temp3
	clr temp4
	rcall FUNKTION_HEX_ASC_32	; INPUT: temp1...4 OUTPUT: Temp1...8
	STS(adr_LCD_PAGE0+3),temp2
	STS(adr_LCD_PAGE0+4),temp1
	ldi temp,'.'
	STS(adr_LCD_PAGE0+5),temp
	; JAHR		
	LDS temp1,(adr_JAHR)
	clr temp2
	clr temp3
	clr temp4
	rcall FUNKTION_HEX_ASC_32	; INPUT: temp1...4 OUTPUT: Temp1...8
	STS(adr_LCD_PAGE0+6),temp2
	STS(adr_LCD_PAGE0+7),temp1
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
LCD_ANZEIGE_DATUM_RECHTS_KURZ:
	; TAG		
	LDS temp1,(adr_TAG)
	clr temp2
	clr temp3
	clr temp4
	rcall FUNKTION_HEX_ASC_32	; INPUT: temp1...4 OUTPUT: Temp1...8
	STS(adr_LCD_PAGE0+13),temp2
	STS(adr_LCD_PAGE0+14),temp1
	ldi temp,'.'
	STS(adr_LCD_PAGE0+15),temp
	; MONAT 	
	LDS temp1,(adr_MONAT)
	clr temp2
	clr temp3
	clr temp4
	rcall FUNKTION_HEX_ASC_32	; INPUT: temp1...4 OUTPUT: Temp1...8
	STS(adr_LCD_PAGE0+16),temp2
	STS(adr_LCD_PAGE0+17),temp1
	ldi temp,'.'
	STS(adr_LCD_PAGE0+18),temp
	; JAHR		
	LDS temp1,(adr_JAHR)
	clr temp2
	clr temp3
	clr temp4
	rcall FUNKTION_HEX_ASC_32	; INPUT: temp1...4 OUTPUT: Temp1...8
	STS(adr_LCD_PAGE0+19),temp2
	STS(adr_LCD_PAGE0+20),temp1
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
LCD_ANZEIGE_EDIT_KURZ:
	rcall LCD_PAGE_0_CLEAR
	ldi temp,'E'
	STS(adr_LCD_PAGE0+0),temp
	ldi temp,'D'
	STS(adr_LCD_PAGE0+1),temp
	ldi temp,'I'
	STS(adr_LCD_PAGE0+2),temp
	ldi temp,'T'
	STS(adr_LCD_PAGE0+3),temp
	ldi temp,':'
	STS(adr_LCD_PAGE0+4),temp
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
LCD_AUSGABE_ZAHL_3_STELLEN_TEMP1:
	clr temp2
	clr temp3
	clr temp4
	rcall FUNKTION_HEX_ASC_32
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; mit Vorzeichen														
LCD_AUSGABE_ZAHL_5_STELLEN_NEGATIV_FORMATIERT_TEMP1_TEMP2:
	tst temp2
	brmi LCD_AUSGABE_ZAHL_5_STELLEN_NEGATIV_TEMP1_TEMP2_MINUS
	ldi temp6,'+'	; VORZEICHEN	
	push temp6	; VORZEICHEN	
	rjmp LCD_AUSGABE_ZAHL_5_STELLEN_NEGATIV_TEMP1_TEMP2_START
LCD_AUSGABE_ZAHL_5_STELLEN_NEGATIV_TEMP1_TEMP2_MINUS:
	ldi temp6,'-'	; VORZEICHEN	
	push temp6	; VORZEICHEN	
	com temp1
	com temp2
	add temp1,EINS
	adc temp2,NULL
LCD_AUSGABE_ZAHL_5_STELLEN_NEGATIV_TEMP1_TEMP2_START:
	clr temp3
	clr temp4
	rcall FUNKTION_HEX_ASC_32
	pop temp6	; VORZEICHEN	
;------------------------------------------------------------------------
	cpi temp5,'0'	; 0 ?	
	brne LCD_AUSGABE_ZAHL_5_STELLEN_NEGATIV_FORMATIERT_RUN
	mov temp5,temp6	; VORZEICHEN	
	ldi temp6,' '	; SPACE			
;------------------------------------------------------------------------
	cpi temp4,'0'	; 0 ?	
	brne LCD_AUSGABE_ZAHL_5_STELLEN_NEGATIV_FORMATIERT_RUN
	mov temp4,temp5	; VORZEICHEN	
	ldi temp5,' '	; SPACE			
;------------------------------------------------------------------------
	cpi temp3,'0'	; 0 ?	
	brne LCD_AUSGABE_ZAHL_5_STELLEN_NEGATIV_FORMATIERT_RUN
	mov temp3,temp4	; VORZEICHEN	
	ldi temp4,' '	; SPACE			
;------------------------------------------------------------------------
	cpi temp2,'0'	; 0 ?	
	brne LCD_AUSGABE_ZAHL_5_STELLEN_NEGATIV_FORMATIERT_RUN
	mov temp2,temp3	; VORZEICHEN	
	ldi temp3,' '	; SPACE			
;------------------------------------------------------------------------
LCD_AUSGABE_ZAHL_5_STELLEN_NEGATIV_FORMATIERT_RUN:
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
;																			
;	Value: 0...	99.999.999													
;																			
;	INPUT: 	temp1	(BYTE1)													
;	 		temp2	(BYTE2)													
;			temp3	(BYTE3)													
;			temp4	(BYTE4)													
;																			
;	OUTPUT:	temp1	(		   1-er Stelle)									
;			temp2	(		  10-er Stelle)									
;			temp3	(        100-er Stelle)									
;			temp4	(      1.000-er Stelle)									
;			temp5	(     10.000-er Stelle)									
;			temp6	(    100.000-er Stelle)									
;			temp7	(  1.000.000-er Stelle)									
;			temp8	( 10.000.000-er Stelle)									
; 																			
; rcall FUNKTION_HEX_ASC_32	; INPUT: temp1...4 OUTPUT: Temp1...8			
; 																			
FUNKTION_HEX_ASC_32:
	clr temp
FUNKTION_HEX_ASC_10000000:; 10.000.000
	inc temp
	subi temp1, BYTE1    (10000000)
	sbci temp2, BYTE2    (10000000)
	sbci temp3, BYTE3    (10000000)
	sbci temp4, BYTE4    (10000000)
	brcc FUNKTION_HEX_ASC_10000000
	dec  temp
	subi temp, -48		; HEX->ASC
	push temp           ; temp (wird temp8) auf dem Stack sichern            
	subi temp1, BYTE1   (-10000000)
	sbci temp2, BYTE2   (-10000000)
	sbci temp3, BYTE3   (-10000000)
	sbci temp4, BYTE4   (-10000000)
	clr temp
FUNKTION_HEX_ASC_1000000:
	inc temp
	subi temp1, BYTE1    (1000000)
	sbci temp2, BYTE2    (1000000)
	sbci temp3, BYTE3    (1000000)
	brcc FUNKTION_HEX_ASC_1000000
	dec  temp
	subi temp, -48		; HEX->ASC
	push temp           ; temp (wird temp7) auf dem Stack sichern            
	subi temp1, BYTE1   (-1000000)
	sbci temp2, BYTE2   (-1000000)
	sbci temp3, BYTE3   (-1000000)
	clr temp
FUNKTION_HEX_ASC_100000:
	inc temp
	subi temp1, BYTE1    (100000)
	sbci temp2, BYTE2    (100000)
	sbci temp3, BYTE3    (100000)
	brcc FUNKTION_HEX_ASC_100000
	dec  temp
	subi temp, -48		; HEX->ASC
	push temp           ; temp (wird temp6) auf dem Stack sichern            
	subi temp1, BYTE1   (-100000)
	sbci temp2, BYTE2   (-100000)
	sbci temp3, BYTE3   (-100000)
	clr temp
FUNKTION_HEX_ASC_10000:
	inc temp
	subi temp1, BYTE1    (10000)
	sbci temp2, BYTE2    (10000)
	sbci temp3, BYTE3    (10000)
	brcc FUNKTION_HEX_ASC_10000
	dec  temp
	subi temp, -48		; HEX->ASC
	push temp           ; temp (wird temp5) auf dem Stack sichern            
	subi temp1, BYTE1  (-10000)
	sbci temp2, BYTE2  (-10000)
	sbci temp3, BYTE3  (-10000)
	clr temp
FUNKTION_HEX_ASC_1000:
	inc temp
	subi temp1, low  (1000)
	sbci temp2, HIGH (1000)
	brcc FUNKTION_HEX_ASC_1000
	dec temp
	subi temp, -48		; HEX->ASC
	push temp           ; temp (wird temp4) auf dem Stack sichern            
	subi temp1, low  (-1000)
	sbci temp2, HIGH (-1000)
	clr temp
FUNKTION_HEX_ASC_100:
	inc temp
	subi temp1, low  (100)
	sbci temp2, HIGH (100)
	brcc FUNKTION_HEX_ASC_100
	dec temp
	subi temp, -48		; HEX->ASC
	push temp           ; temp (wird temp3) auf dem Stack sichern            
	subi temp1, low  (-100)
	sbci temp2, HIGH (-100)
	clr temp
FUNKTION_HEX_ASC_10:
	inc temp
	subi temp1, low  (10)
	sbci temp2, HIGH (10)
	brcc FUNKTION_HEX_ASC_10
	dec temp
	subi temp, -48		; HEX->ASC
	push temp           ; temp (wird temp2) auf dem Stack sichern            
	subi temp1, low  (-10)
	sbci temp2, HIGH (-10)
FUNKTION_HEX_ASC_1:	
	subi temp1, -48		; HEX->ASC

	pop	TEMP2			; LESEN vom STACK (KOPIE)
	pop	TEMP3			; LESEN vom STACK (KOPIE)
	pop	TEMP4			; LESEN vom STACK (KOPIE)
	pop	TEMP5			; LESEN vom STACK (KOPIE)
	pop	TEMP6			; LESEN vom STACK (KOPIE)
	pop	TEMP7			; LESEN vom STACK (KOPIE)
	pop	TEMP8			; LESEN vom STACK (KOPIE)
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
LCD_INITIALISIERUNG:
	; RESET			
	cbi PORTB,LCD_RES	; RESET auf LOW		
	rcall wait_100ms
	sbi PORTB,LCD_RES	; RESET  auf HIGH	
	rcall wait_100ms
	; Befehl 2 		
	ldi temp,0x40		; Start Line 0		
	rcall LCD_COMMAND 	
	; Befehl 8 		
	ldi temp,0xA1		; ADC reverse		
	rcall LCD_COMMAND 
	; Befehl 15		
	ldi temp,0xC0		; Normal COM0-COM63	
	rcall LCD_COMMAND 
	; Befehl 9 		
	ldi temp,0xA6		; Display normal	
	rcall LCD_COMMAND 
	; Befehl 11		
	ldi temp,0xA2		; SET BIAS			
	rcall LCD_COMMAND 
	; Befehl 16		
	ldi temp,0x2F		; BOOSTER			
	rcall LCD_COMMAND 
	; Befehl 20		
	ldi temp,0xF8		; Set Booster internal to 4x
	rcall LCD_COMMAND 
	ldi temp,0x00		
	rcall LCD_COMMAND 
	; Befehl  17	
	ldi temp,0x27		; 
	rcall LCD_COMMAND 
	; Befehl  18	
	ldi temp,0x81		; CONTRAST			
	rcall LCD_COMMAND 
	ldi temp,22			; CONTRAST (0...22...31)	
	rcall LCD_COMMAND 
	; Befehl  19	
	ldi temp,0xAC		; No indicator		
	rcall LCD_COMMAND 
	ldi temp,0x00		
	rcall LCD_COMMAND 
	; Befehl  		
	ldi temp,0xAF		; Display on		
	rcall LCD_COMMAND 

ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; rcall LCD_CONTRAST	; inp (adr_LCD_KONTRAST)	(0...22...31)				
LCD_CONTRAST:
	; Befehl  18	
	ldi temp,0x81					; CONTRAST			
	rcall LCD_COMMAND 
	LDS temp,(adr_LCD_KONTRAST)		; CONTRAST (0...22...31)	
	; ERROR			
	cpi temp,15
	brlo LCD_CONTRAST_w
	cpi temp,30
	brsh LCD_CONTRAST_w
	rjmp LCD_CONTRAST_RUN
LCD_CONTRAST_w:
	ldi temp,15
LCD_CONTRAST_RUN:
	STS(adr_LCD_KONTRAST),temp
	rcall LCD_COMMAND 
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; inp: temp																		
;																				
;	rcall LCD_COMMAND ; inp: temp												
;																				
LCD_DATA:
	push temp	; sichern			
	sbi PORTB,LCD_A0			; A0 auf HIGH	
	cbi PORTB,LCD_CS			; CS auf LOW	
	rcall SPI_TX_RX_TEMP		; SPI INP: TEMP OUT: temp
	sbi PORTB,LCD_CS			; CS auf HIGH	
	pop temp	; wiederherstellen	
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; inp: temp																		
;																				
;	rcall LCD_COMMAND ; inp: temp												
;																				
LCD_COMMAND:
	push temp	; sichern			
	cbi PORTB,LCD_A0			; A0 auf LOW	
	cbi PORTB,LCD_CS			; CS auf LOW	
	rcall SPI_TX_RX_TEMP		; SPI INP: TEMP OUT: temp
	sbi PORTB,LCD_CS			; CS auf HIGH	
	pop temp	; wiederherstellen	
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; inp: temp																		
;																				
;	rcall LCD_PAGE_SET ; PAGE inp: temp (0..7)									
;																				
LCD_PAGE_SET:
	push temp	; sichern			

	; Fehlerprfung	
	andi temp,0b00000111
	; Bitmuster		
	ori  temp,0b10110000
	rcall LCD_COMMAND
	; SPALTE auf NULL
	rcall LCD_COLUMN_NULL 

	pop temp	; wiederherstellen	
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
;																				
; SPALTE NULL setzen (ganz links = 0)											
;																				
; rcall LCD_COLUMN_SET ; SPALTE NP: temp (0...127)								
;																				
LCD_COLUMN_SET:
	push temp				; sichern			
	push temp				; sichern			

	; Fehlercheck		
	andi temp,0b01111111		
	; Nibles tauschen	
	swap temp
	; Bitmuster			
	andi temp,0b00001111
	; Bitmuster			
	ORI  temp,0b00010000	; uper-BIT	
	rcall LCD_COMMAND

	pop temp				; wiederherstellen	
	; Bitmuster			
	andi temp,0b00001111	; lower-BIT	
	rcall LCD_COMMAND
	
	pop temp				; wiederherstellen	
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
;																				
; SPALTE auf NULL setzen (ganz links)											
;																				
; rcall LCD_COLUMN_NULL ; SPALTE auf NULL										
;																				
LCD_COLUMN_NULL:
	push temp			; sichern			

	ldi temp,0b00010000	; uper-BIT	
	rcall LCD_COMMAND

	ldi temp,0b00000000	; lower-BIT	
	rcall LCD_COMMAND
	
	pop temp			; wiederherstellen	
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
;																				
; CLEAR																			
;																				
LCD_CLEAR:
	push temp	; sichern	
	push temp1

	; PAGE 0	
	ldi temp,0
	rcall LCD_CLEAR_SCHLEIFE
	; PAGE 1	
	ldi temp,1
	rcall LCD_CLEAR_SCHLEIFE
	; PAGE 2	
	ldi temp,2
	rcall LCD_CLEAR_SCHLEIFE
	; PAGE 3	
	ldi temp,3
	rcall LCD_CLEAR_SCHLEIFE
	; PAGE 4	
	ldi temp,4
	rcall LCD_CLEAR_SCHLEIFE
	; PAGE 5	
	ldi temp,5
	rcall LCD_CLEAR_SCHLEIFE
	; PAGE 6	
	ldi temp,6
	rcall LCD_CLEAR_SCHLEIFE
	; PAGE 7	
	ldi temp,7
	rcall LCD_CLEAR_SCHLEIFE
	; COLUMN-NULL	
	rcall LCD_COLUMN_NULL
	; PAGE-NULL		
	clr temp
	rcall LCD_PAGE_SET ; PAGE inp: temp (0..7)

	pop temp1	; wiederherstellen
	pop temp
ret
;---------------
LCD_CLEAR_SCHLEIFE:
	rcall LCD_PAGE_SET 		; PAGE inp: temp (0..7)	
	; Schleife	
	ldi temp1,128
LCD_CLEAR_SCHLEIFE_w:	
	clr temp 	; NULL
	rcall LCD_DATA
	dec temp1
	brne LCD_CLEAR_SCHLEIFE_w
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
LCD_VOLL:
	push temp	; sichern	
	push temp1

	; PAGE 0	
	ldi temp,0
	rcall LCD_VOLL_SCHLEIFE
	; PAGE 1	
	ldi temp,1
	rcall LCD_VOLL_SCHLEIFE
	; PAGE 2	
	ldi temp,2
	rcall LCD_VOLL_SCHLEIFE
	; PAGE 3	
	ldi temp,3
	rcall LCD_VOLL_SCHLEIFE
	; PAGE 4	
	ldi temp,4
	rcall LCD_VOLL_SCHLEIFE
	; PAGE 5	
	ldi temp,5
	rcall LCD_VOLL_SCHLEIFE
	; PAGE 6	
	ldi temp,6
	rcall LCD_VOLL_SCHLEIFE
	; PAGE 7	
	ldi temp,7
	rcall LCD_VOLL_SCHLEIFE

	pop temp1	; wiederherstellen
	pop temp
ret
;---------------
LCD_VOLL_SCHLEIFE:
	rcall LCD_PAGE_SET 		; PAGE inp: temp (0..7)	
	; Schleife	
	ldi temp1,128
LCD_VOLL_SCHLEIFE_w:	
	ldi temp,0b11111111
	rcall LCD_DATA
	dec temp1
	brne LCD_VOLL_SCHLEIFE_w

ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; eine Text anzeigen INP: Z (TABELLE)										
ANZEIGE_TEXT_Z_Y:
	LPM temp, Z+   			; aus Tabelle laden und Zeiger um 1 erhhen	
	tst temp  			
	breq ANZEIGE_TEXT_e 	; Sprung
	ST Y+,temp
	rjmp ANZEIGE_TEXT_Z_Y
ANZEIGE_TEXT_e:
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
;																				
; PAGE0 z.B. ein TEXT															
; PAGE1...7 (7 PAGES * 128 SPALTEN = 896 BYTES=7.168 BIT bzw PIXEL				
;																				
LCD_ZEICHNEN:
	cbi (LED_GRUEN_PORT),LED_GRUEN_PIN_NR		; GRN an   		
	rcall LCD_ZEICHNEN_PAGE_0					; oberste ZEILE		
	rcall LCD_ZEICHNEN_PAGE_1
	rcall LCD_ZEICHNEN_PAGE_2
	rcall LCD_ZEICHNEN_PAGE_3
	rcall LCD_ZEICHNEN_PAGE_4
	rcall LCD_ZEICHNEN_PAGE_5
	rcall LCD_ZEICHNEN_PAGE_6
	rcall LCD_ZEICHNEN_PAGE_7
	sbi (LED_GRUEN_PORT),LED_GRUEN_PIN_NR		; GRN aus   		
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
LCD_PAGE_0_CLEAR:
	clr temp
	STS(adr_LCD_PAGE0+0),temp
	STS(adr_LCD_PAGE0+1),temp
	STS(adr_LCD_PAGE0+2),temp
	STS(adr_LCD_PAGE0+3),temp
	STS(adr_LCD_PAGE0+4),temp
	STS(adr_LCD_PAGE0+5),temp
	STS(adr_LCD_PAGE0+6),temp
	STS(adr_LCD_PAGE0+7),temp
	STS(adr_LCD_PAGE0+8),temp
	STS(adr_LCD_PAGE0+9),temp
	STS(adr_LCD_PAGE0+10),temp
	STS(adr_LCD_PAGE0+11),temp
	STS(adr_LCD_PAGE0+12),temp
	STS(adr_LCD_PAGE0+13),temp
	STS(adr_LCD_PAGE0+14),temp
	STS(adr_LCD_PAGE0+15),temp
	STS(adr_LCD_PAGE0+16),temp
	STS(adr_LCD_PAGE0+17),temp
	STS(adr_LCD_PAGE0+18),temp
	STS(adr_LCD_PAGE0+19),temp
	STS(adr_LCD_PAGE0+20),temp
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
LCD_ZEICHNEN_PAGE_0:
	; PAGE 0 (hier knnte z.B. ein Text stehen)	
	ldi temp,0
	rcall LCD_PAGE_SET 		; PAGE inp: temp (0..7)	

	LDS temp,(adr_LCD_PAGE0+0)
	rcall LCD_AUSGABE_PAGE0_SCHLEIFE	; inp: temp
	LDS temp,(adr_LCD_PAGE0+1)
	rcall LCD_AUSGABE_PAGE0_SCHLEIFE	; inp: temp
	LDS temp,(adr_LCD_PAGE0+2)
	rcall LCD_AUSGABE_PAGE0_SCHLEIFE	; inp: temp
	LDS temp,(adr_LCD_PAGE0+3)
	rcall LCD_AUSGABE_PAGE0_SCHLEIFE	; inp: temp
	LDS temp,(adr_LCD_PAGE0+4)
	rcall LCD_AUSGABE_PAGE0_SCHLEIFE	; inp: temp
	LDS temp,(adr_LCD_PAGE0+5)
	rcall LCD_AUSGABE_PAGE0_SCHLEIFE	; inp: temp
	LDS temp,(adr_LCD_PAGE0+6)
	rcall LCD_AUSGABE_PAGE0_SCHLEIFE	; inp: temp
	LDS temp,(adr_LCD_PAGE0+7)
	rcall LCD_AUSGABE_PAGE0_SCHLEIFE	; inp: temp
	LDS temp,(adr_LCD_PAGE0+8)
	rcall LCD_AUSGABE_PAGE0_SCHLEIFE	; inp: temp
	LDS temp,(adr_LCD_PAGE0+9)
	rcall LCD_AUSGABE_PAGE0_SCHLEIFE	; inp: temp
	LDS temp,(adr_LCD_PAGE0+10)
	rcall LCD_AUSGABE_PAGE0_SCHLEIFE	; inp: temp
	LDS temp,(adr_LCD_PAGE0+11)
	rcall LCD_AUSGABE_PAGE0_SCHLEIFE	; inp: temp
	LDS temp,(adr_LCD_PAGE0+12)
	rcall LCD_AUSGABE_PAGE0_SCHLEIFE	; inp: temp
	LDS temp,(adr_LCD_PAGE0+13)
	rcall LCD_AUSGABE_PAGE0_SCHLEIFE	; inp: temp
	LDS temp,(adr_LCD_PAGE0+14)
	rcall LCD_AUSGABE_PAGE0_SCHLEIFE	; inp: temp
	LDS temp,(adr_LCD_PAGE0+15)
	rcall LCD_AUSGABE_PAGE0_SCHLEIFE	; inp: temp
	LDS temp,(adr_LCD_PAGE0+16)
	rcall LCD_AUSGABE_PAGE0_SCHLEIFE	; inp: temp
	LDS temp,(adr_LCD_PAGE0+17)
	rcall LCD_AUSGABE_PAGE0_SCHLEIFE	; inp: temp
	LDS temp,(adr_LCD_PAGE0+18)
	rcall LCD_AUSGABE_PAGE0_SCHLEIFE	; inp: temp
	LDS temp,(adr_LCD_PAGE0+19)
	rcall LCD_AUSGABE_PAGE0_SCHLEIFE	; inp: temp
	LDS temp,(adr_LCD_PAGE0+20)
	rcall LCD_AUSGABE_PAGE0_SCHLEIFE	; inp: temp
	; letzten beiden SPALTEN			
	ldi temp,0
	rcall LCD_DATA						; INP: temp		
	rcall LCD_DATA						; INP: temp		
ret
;-----------------------------------
LCD_AUSGABE_PAGE0_SCHLEIFE:
	; Zeiger initialisieren		
	ldi ZL, low (TABELLE_ASCII*2)	; DATEN	- ZEIGER-initialisieren	
	ldi ZH, high(TABELLE_ASCII*2)	
	; addieren					
	add ZL,temp	;
	adc ZH,NULL
	add ZL,temp	;
	adc ZH,NULL
	add ZL,temp	;
	adc ZH,NULL	
	add ZL,temp	;
	adc ZH,NULL
	add ZL,temp	;
	adc ZH,NULL	
	add ZL,temp	;
	adc ZH,NULL	
	; laden und zeichnen		
	LPM temp, Z+   				; aus Tabelle laden und Zeiger um 1 erhhen	
	rcall LCD_DATA				; INP: temp		
	LPM temp, Z+   				; aus Tabelle laden und Zeiger um 1 erhhen	
	rcall LCD_DATA				; INP: temp		
	LPM temp, Z+   				; aus Tabelle laden und Zeiger um 1 erhhen	
	rcall LCD_DATA				; INP: temp		
	LPM temp, Z+   				; aus Tabelle laden und Zeiger um 1 erhhen	
	rcall LCD_DATA				; INP: temp		
	LPM temp, Z+   				; aus Tabelle laden und Zeiger um 1 erhhen	
	rcall LCD_DATA				; INP: temp		
	LPM temp, Z+   				; aus Tabelle laden und Zeiger um 1 erhhen	
	rcall LCD_DATA				; INP: temp		
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
LCD_ZEICHNEN_PAGE_1:
	; PAGE umschalten				
	ldi temp,1
	rcall LCD_PAGE_SET 		; PAGE inp: temp (0..7)	
	; Y-ZEIGER  (DATENFELD)					
	ldi YL, LOW(adr_LCD_DATENFELD+0)
	ldi YH,HIGH(adr_LCD_DATENFELD+0)
	rjmp LCD_ZEICHNEN_PAGE_Y
; ##############################################################################
; ##############################################################################
; ##############################################################################
LCD_ZEICHNEN_PAGE_2:
	; PAGE umschalten				
	ldi temp,2
	rcall LCD_PAGE_SET 		; PAGE inp: temp (0..7)	
	rjmp LCD_ZEICHNEN_PAGE_Y
; ##############################################################################
; ##############################################################################
; ##############################################################################
LCD_ZEICHNEN_PAGE_3:
	; PAGE umschalten				
	ldi temp,3
	rcall LCD_PAGE_SET 		; PAGE inp: temp (0..7)	
	rjmp LCD_ZEICHNEN_PAGE_Y
; ##############################################################################
; ##############################################################################
; ##############################################################################
; Mittellinie																	
LCD_ZEICHNEN_PAGE_4:
	; PAGE umschalten				
	ldi temp,4
	rcall LCD_PAGE_SET 		; PAGE inp: temp (0..7)	
	rjmp LCD_ZEICHNEN_PAGE_Y
; ##############################################################################
; ##############################################################################
; ##############################################################################
LCD_ZEICHNEN_PAGE_5:
	; PAGE umschalten				
	ldi temp,5
	rcall LCD_PAGE_SET 		; PAGE inp: temp (0..7)	
	rjmp LCD_ZEICHNEN_PAGE_Y
; ##############################################################################
; ##############################################################################
; ##############################################################################
LCD_ZEICHNEN_PAGE_6:
	; PAGE umschalten				
	ldi temp,6
	rcall LCD_PAGE_SET 		; PAGE inp: temp (0..7)	
	rjmp LCD_ZEICHNEN_PAGE_Y
; ##############################################################################
; ##############################################################################
; ##############################################################################
LCD_ZEICHNEN_PAGE_7:
	; PAGE umschalten				
	ldi temp,7
	rcall LCD_PAGE_SET 		; PAGE inp: temp (0..7)	
	rjmp LCD_ZEICHNEN_PAGE_Y
; ##############################################################################
; ##############################################################################
; ##############################################################################
; INP: Y																		
LCD_ZEICHNEN_PAGE_Y:
	ldi temp9, 128
LCD_ZEICHNEN_PAGE_Y_s:
	LD temp,Y+ ; SRAM read	
	rcall LCD_DATA				; INP: temp		
	dec temp9
	brne LCD_ZEICHNEN_PAGE_Y_s
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
DIAGRAMM_ZEICHNEN_XYZ:
	LDS temp,(adr_ALARM_WERT)
	cpi temp,(12)
	brlo DIAGRAMM_ZEICHNEN_XYZ_RUN
	ret
DIAGRAMM_ZEICHNEN_XYZ_RUN:

	rcall DATENFELD_SCHIEBEN

	LDS temp1,(adr_BMA020_X)
	subi temp1,-42
	ldi temp2,  42
	rcall DIAGRAMM_BALKEN_TEMP1_TEMP2

	LDS temp1,(adr_BMA020_Y)
	subi temp1,-28
	ldi temp2,  28
	rcall DIAGRAMM_BALKEN_TEMP1_TEMP2
	
	LDS temp1,(adr_BMA020_Z)
	subi temp1,-14	
	ldi temp2,  14
	rcall DIAGRAMM_BALKEN_TEMP1_TEMP2

ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; zeichnet einen BALKEN in das DIAGRAMM ganz rechts								
DIAGRAMM_BALKEN_TEMP1_TEMP2:
	cp temp1,temp2
	brne DIAGRAMM_BALKEN_TEMP1_TEMP2_w
	rjmp DIAGRAMM_PUNKT_TEMP1
DIAGRAMM_BALKEN_TEMP1_TEMP2_w:
	brlo DIAGRAMM_BALKEN_TEMP1_TEMP2_ww
	mov temp, temp1
	mov temp1,temp2
	mov temp2,temp
DIAGRAMM_BALKEN_TEMP1_TEMP2_ww:
	rcall DIAGRAMM_PUNKT_TEMP1
	inc temp1
	rjmp DIAGRAMM_BALKEN_TEMP1_TEMP2
; ##############################################################################
; ##############################################################################
; ##############################################################################
; zeichnet einen Punkt in das Diagramm ganz rechts								
DIAGRAMM_PUNKT_TEMP1:
	push temp1
	; PAGES bestimmen		
	tst temp1
	brmi DIAGRAMM_PUNKT_PAGE7_OVERLOW
	cpi temp1,56
	brsh DIAGRAMM_PUNKT_PAGE1_OVERLOW
	cpi temp1,48
	brsh DIAGRAMM_PUNKT_PAGE1
	cpi temp1,40
	brsh DIAGRAMM_PUNKT_PAGE2
	cpi temp1,32
	brsh DIAGRAMM_PUNKT_PAGE3
	cpi temp1,24
	brsh DIAGRAMM_PUNKT_PAGE4
	cpi temp1,16
	brsh DIAGRAMM_PUNKT_PAGE5
	cpi temp1,8
	brsh DIAGRAMM_PUNKT_PAGE6
	rjmp DIAGRAMM_PUNKT_PAGE7
;-------------------------------------------------------------------------------
DIAGRAMM_PUNKT_PAGE1_OVERLOW:
	ldi temp1,0b00000001
	LDS temp,(adr_LCD_DATENFELD+127+128*0)
	or temp1,temp
	STS(adr_LCD_DATENFELD+127+128*0),TEMP1
	pop temp1
	ret
;-------------------------------------------------------------------------------
DIAGRAMM_PUNKT_PAGE7_OVERLOW:
	ldi temp1,0b10000000
	LDS temp,(adr_LCD_DATENFELD+127+128*6)
	or temp1,temp
	STS(adr_LCD_DATENFELD+127+128*6),temp1
	pop temp1
	ret
;-------------------------------------------------------------------------------
DIAGRAMM_PUNKT_PAGE1:
	rcall DIAGRAMM_PUNKT_BIT_TEMP1
	LDS temp,(adr_LCD_DATENFELD+127+128*0)
	or temp1,temp
	STS(adr_LCD_DATENFELD+127+128*0),TEMP1
	pop temp1
	ret
DIAGRAMM_PUNKT_PAGE2:
	rcall DIAGRAMM_PUNKT_BIT_TEMP1
	LDS temp,(adr_LCD_DATENFELD+127+128*1)
	or temp1,temp
	STS(adr_LCD_DATENFELD+127+128*1),TEMP1
	pop temp1
	ret
DIAGRAMM_PUNKT_PAGE3:
	rcall DIAGRAMM_PUNKT_BIT_TEMP1
	LDS temp,(adr_LCD_DATENFELD+127+128*2)
	or temp1,temp
	STS(adr_LCD_DATENFELD+127+128*2),TEMP1
	pop temp1
	ret
DIAGRAMM_PUNKT_PAGE4:
	rcall DIAGRAMM_PUNKT_BIT_TEMP1
	LDS temp,(adr_LCD_DATENFELD+127+128*3)
	or temp1,temp
	STS(adr_LCD_DATENFELD+127+128*3),TEMP1
	pop temp1
	ret
DIAGRAMM_PUNKT_PAGE5:
	rcall DIAGRAMM_PUNKT_BIT_TEMP1
	LDS temp,(adr_LCD_DATENFELD+127+128*4)
	or temp1,temp
	STS(adr_LCD_DATENFELD+127+128*4),TEMP1
	pop temp1
	ret
DIAGRAMM_PUNKT_PAGE6:
	rcall DIAGRAMM_PUNKT_BIT_TEMP1
	LDS temp,(adr_LCD_DATENFELD+127+128*5)
	or temp1,temp
	STS(adr_LCD_DATENFELD+127+128*5),temp1
	pop temp1
	ret
DIAGRAMM_PUNKT_PAGE7:
	rcall DIAGRAMM_PUNKT_BIT_TEMP1
	LDS temp,(adr_LCD_DATENFELD+127+128*6)
	or temp1,temp
	STS(adr_LCD_DATENFELD+127+128*6),temp1
	pop temp1
	ret
;-------------------------------------------------------------------------------
DIAGRAMM_PUNKT_BIT_TEMP1:
	andi temp1,0b00000111	; Bitmuster			
	cpi temp1,0
	breq DIAGRAMM_PUNKT_0
	cpi temp1,1
	breq DIAGRAMM_PUNKT_1
	cpi temp1,2
	breq DIAGRAMM_PUNKT_2
	cpi temp1,3
	breq DIAGRAMM_PUNKT_3
	cpi temp1,4
	breq DIAGRAMM_PUNKT_4
	cpi temp1,5
	breq DIAGRAMM_PUNKT_5
	cpi temp1,6
	breq DIAGRAMM_PUNKT_6
	rjmp DIAGRAMM_PUNKT_7
DIAGRAMM_PUNKT_0:
	ldi temp1,0b10000000
	ret
DIAGRAMM_PUNKT_1:
	ldi temp1,0b01000000
	ret
DIAGRAMM_PUNKT_2:
	ldi temp1,0b00100000
	ret
DIAGRAMM_PUNKT_3:
	ldi temp1,0b00010000
	ret
DIAGRAMM_PUNKT_4:
	ldi temp1,0b00001000
	ret
DIAGRAMM_PUNKT_5:
	ldi temp1,0b00000100
	ret
DIAGRAMM_PUNKT_6:
	ldi temp1,0b00000010
	ret
DIAGRAMM_PUNKT_7:
	ldi temp1,0b00000001
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; das DIAGRAMM um ein Pixel nach links schieben									
DATENFELD_SCHIEBEN:
	; Z-ZEIGER	
	ldi ZL,LOW (adr_LCD_DATENFELD)
	ldi ZH,HIGH(adr_LCD_DATENFELD)
	rcall DATENFELD_SCHIEBEN_AKTION
	rcall DATENFELD_SCHIEBEN_AKTION
	rcall DATENFELD_SCHIEBEN_AKTION
	rcall DATENFELD_SCHIEBEN_AKTION
	rcall DATENFELD_SCHIEBEN_AKTION
	rcall DATENFELD_SCHIEBEN_AKTION
	rcall DATENFELD_SCHIEBEN_AKTION
ret
;-------------------------------------------------------------------------------
DATENFELD_SCHIEBEN_AKTION:
	push ZL
	push ZH
	; Z+1		
	adiw ZL,1
	; Schleife	
	ldi temp9,127
DATENFELD_SCHIEBEN_w:
	; laden 	
	LD temp,Z
	; CLEAR		
	ST Z, NULL
	; Z-1		
	SBIW ZL,1
	; ablegen	
	ST Z, temp
	; Z+2		
	adiw ZL,2
	; Schleife	
	dec temp9
	brne DATENFELD_SCHIEBEN_w
	pop ZH
	pop ZL
	ldi temp,128
	add ZL,temp
	adc ZH,NULL
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
