; ##############################################################################
; ##############################################################################
; ##############################################################################
USART_INITIALISIEREN:
	ldi temp,TAKT/(BAUD*16)-1  		; Baudrate 								
	out UBRRL,temp
   	ldi temp, (1<<URSEL)|(3<<UCSZ0)	; Frame-Format: 8 Bit					
    out UCSRC, temp
    sbi UCSRB, RXCIE                ; Interrupt bei Empfang	aktivieren		
    cbi UCSRB, RXEN 				; RX aktivieren (Empfang)      			
	sbi UCSRB, TXEN  				; TX aktivieren                 		
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; 	INPUT: temp1														
;																		
;	rcall SENDEN	; INP: TEMP1										
;																		
USART_TX_TEMP1:
	WDR 						; Watch-Dog-RESET					
	sbis UCSRA,UDRE  		   	; Warten bis UDR frei             	
	rjmp USART_TX_TEMP1			; Sprung							
	out UDR, temp1				; senden							
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
USART_OUTPUT_DATA:
; VORSPANN				
	ldi temp1,'*'
	rcall USART_TX_TEMP1				; TX				
; DATEN					
	LDS temp1,(adr_BMA020_X_MSB)
	rcall USART_TX_TEMP1				; TX				
	LDS temp1,(adr_BMA020_X_LSB)
	rcall USART_TX_TEMP1				; TX				
	LDS temp1,(adr_BMA020_Y_MSB)
	rcall USART_TX_TEMP1				; TX				
	LDS temp1,(adr_BMA020_Y_LSB)
	rcall USART_TX_TEMP1				; TX				
	LDS temp1,(adr_BMA020_Z_MSB)
	rcall USART_TX_TEMP1				; TX				
	LDS temp1,(adr_BMA020_Z_LSB)
	rcall USART_TX_TEMP1				; TX				
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
